#ifndef DFA_H
#define DFA_H

#include <grammar.h>

typedef struct _dfa_state_t dfa_state_t;
typedef struct _dfa_t dfa_t;

dfa_state_t* dfa_state_new (gint, gboolean);
void dfa_state_delete (dfa_state_t*);
dfa_t* dfa_new (nextcb, gpointer);
void dfa_delete (dfa_t*);
gboolean dfa_add (dfa_t*, dfa_state_t*, symbol_t*, dfa_state_t*);
gpointer dfa_build (dfa_t*);

#endif
